
stages:
  - release


release-api-docker-image:
  image: docker:20.10.16
  stage: release
  only:
    changes:
      - services/api/**/*
  services:
    - docker:20.10.16-dind
  script:
    - echo -n $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE/api:latest services/api/
    - docker push $CI_REGISTRY_IMAGE/api:latest


release-ui-docker-image:
  image: docker:20.10.16
  stage: release
  only:
    changes:
      - services/ui/**/*
  services:
    - docker:20.10.16-dind
  script:
    - echo -n $CI_REGISTRY_PASSWORD | docker login -u $CI_REGISTRY_USER --password-stdin $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE/ui:latest services/ui/
    - docker push $CI_REGISTRY_IMAGE/ui:latest


release-helm-chart:
  stage: release
  only:
    changes:
      - chart/**/*
  script:
    # ensure user ~/bin folder exists and is in the path
    - mkdir -p "$HOME/bin"
    - PATH="$HOME/bin:$PATH"
    # download helm and add it to the ~/bin/folder
    - wget -qO helm.tar.gz https://get.helm.sh/helm-v3.10.0-linux-amd64.tar.gz
    - tar -zxvf helm.tar.gz
    - mv linux-amd64/helm $HOME/bin/helm
    # add chartmuseum plugin to helm
    - helm plugin install https://github.com/chartmuseum/helm-push
    # add repo
    - helm repo add --username gitlab-ci-token --password glpat-d7PXAXyAdeErmZH2tzwz squidploy https://gitlab.com/api/v4/projects/39721728/packages/helm/stable

    - PACKAGE_NAME=$(helm package chart/ | awk -F/ '{print $NF}')
    - helm cm-push $PACKAGE_NAME squidploy
